#include <windows.h>

LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);
HINSTANCE g_hInst;
HWND hWndMain;
LPCTSTR lpszClass=TEXT("DevCap");

int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance
	  ,LPSTR lpszCmdParam,int nCmdShow)
{
	HWND hWnd;
	MSG Message;
	WNDCLASS WndClass;
	g_hInst=hInstance;
	
	WndClass.cbClsExtra=0;
	WndClass.cbWndExtra=0;
	WndClass.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);
	WndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
	WndClass.hIcon=LoadIcon(NULL,IDI_APPLICATION);
	WndClass.hInstance=hInstance;
	WndClass.lpfnWndProc=(WNDPROC)WndProc;
	WndClass.lpszClassName=lpszClass;
	WndClass.lpszMenuName=NULL;
	WndClass.style=CS_HREDRAW | CS_VREDRAW;
	RegisterClass(&WndClass);

	hWnd=CreateWindow(lpszClass,lpszClass,WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
		NULL,(HMENU)NULL,hInstance,NULL);
	ShowWindow(hWnd,nCmdShow);
	hWndMain=hWnd;
	
	while(GetMessage(&Message,0,0,0)) {
		TranslateMessage(&Message);
		DispatchMessage(&Message);
	}
	return Message.wParam;
}

void DevCap()
{
	PRINTDLG pd;
	HDC hPrtdc;
	DEVMODE *dm;
	char szPrinter[128];
	HANDLE hPrinter;
	PRINTER_INFO_2 *pi;
	DWORD cbNeeded;
	char Mes[256];
	HDC hdc;
	int y=2;

	hdc=GetDC(hWndMain);

	// Ϳ   ϰ DC .
	memset(&pd,0,sizeof(PRINTDLG));
	pd.lStructSize=sizeof(PRINTDLG);
	pd.Flags=PD_RETURNDC;
	pd.hwndOwner=hWndMain;
	pd.nFromPage=1;
	pd.nToPage=1;
	pd.nMinPage=1;
	pd.nMaxPage=1;
	pd.nCopies=1;
	PrintDlg(&pd);
	hPrtdc=pd.hDC;
	if (hPrtdc == NULL) 
		return;

	//  ̸ 
	dm=(DEVMODE *)GlobalLock(pd.hDevMode);
	lstrcpy(szPrinter,(LPCTSTR)dm->dmDeviceName);
	GlobalUnlock(pd.hDevMode);
	wsprintf(Mes," ̸: %s ", szPrinter);
	TextOut(hdc,10,y++*20,Mes,lstrlen(Mes));

	// ȭ ػ 
	int xres, yres,xsize,ysize,xdpi,ydpi,numcolor,rastercap;
	xres = GetDeviceCaps(hPrtdc, HORZRES);
	yres = GetDeviceCaps(hPrtdc, VERTRES);
	xsize = GetDeviceCaps(hPrtdc, HORZSIZE);
	ysize = GetDeviceCaps(hPrtdc, VERTSIZE);
	xdpi = GetDeviceCaps(hPrtdc, LOGPIXELSX);
	ydpi = GetDeviceCaps(hPrtdc, LOGPIXELSY);
	numcolor = GetDeviceCaps(hPrtdc, NUMCOLORS);
	rastercap = GetDeviceCaps(hPrtdc, RASTERCAPS) & RC_STRETCHDIB;

	wsprintf(Mes,"Xũ(ȼ)=%d, Yũ(ȼ)=%d",xres,yres);
	TextOut(hdc,10,y++*20,Mes,lstrlen(Mes));
	wsprintf(Mes,"Xũ(и)=%d, Yũ(и)=%d",xsize,ysize);
	TextOut(hdc,10,y++*20,Mes,lstrlen(Mes));
	wsprintf(Mes,"Xػ=%d, Yػ=%d",xdpi,ydpi);
	TextOut(hdc,10,y++*20,Mes,lstrlen(Mes));
	wsprintf(Mes,"=%d, Ʈ ƮĪ=%s",
		numcolor,rastercap ? "":"Ұ");
	TextOut(hdc,10,y++*20,Mes,lstrlen(Mes));
		
	//   ɷ Ѵ.
	DWORD Collate, Copies, Duplex, Orientation;
	Collate=DeviceCapabilities(szPrinter,szPrinter,DC_COLLATE,NULL,NULL);
	Copies=DeviceCapabilities(szPrinter,szPrinter,DC_COPIES,NULL,NULL);
	Duplex=DeviceCapabilities(szPrinter,szPrinter,DC_DUPLEX,NULL,NULL);
	Orientation=DeviceCapabilities(szPrinter,szPrinter,DC_ORIENTATION,NULL,NULL);

	wsprintf(Mes,"Collate( ξ μ)=%s, Copies(  ִ  ż)=%d",
		Collate ? "":" ",Copies);
	TextOut(hdc,10,y++*20,Mes,lstrlen(Mes));
	wsprintf(Mes,"Duplex( μ)=%s, =%d",
		Duplex ? "":" ",Orientation);
	TextOut(hdc,10,y++*20,Mes,lstrlen(Mes));

	// GetPrinter 
	OpenPrinter(szPrinter,&hPrinter,NULL);
	GetPrinter(hPrinter,2,0,0,&cbNeeded);
	pi=(PRINTER_INFO_2 *)malloc(cbNeeded);
	GetPrinter(hPrinter,2,(LPBYTE)pi,cbNeeded,&cbNeeded);

	wsprintf(Mes," ̸: %s, μ μ ̸ : %s ", 
		pi->pPrinterName, pi->pPrintProcessor);
	TextOut(hdc,10,y++*20,Mes,lstrlen(Mes));

	free(pi);
	ClosePrinter(hPrinter);

	DeleteDC(hPrtdc);
	ReleaseDC(hWndMain,hdc);
}

LRESULT CALLBACK WndProc(HWND hWnd,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	char Mes[]="콺  ư ÿ";

	switch(iMessage) {
	case WM_PAINT:
		hdc=BeginPaint(hWnd, &ps);
		TextOut(hdc,10,10,Mes,lstrlen(Mes));
		EndPaint(hWnd, &ps);
		return 0;
	case WM_LBUTTONDOWN:
		DevCap();
		return 0;
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}
	return(DefWindowProc(hWnd,iMessage,wParam,lParam));
}
