#include <windows.h>

LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);
HINSTANCE g_hInst;
HWND hWndMain;
LPCTSTR lpszClass=TEXT("LandPort1");

int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance
	  ,LPSTR lpszCmdParam,int nCmdShow)
{
	HWND hWnd;
	MSG Message;
	WNDCLASS WndClass;
	g_hInst=hInstance;
	
	WndClass.cbClsExtra=0;
	WndClass.cbWndExtra=0;
	WndClass.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);
	WndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
	WndClass.hIcon=LoadIcon(NULL,IDI_APPLICATION);
	WndClass.hInstance=hInstance;
	WndClass.lpfnWndProc=(WNDPROC)WndProc;
	WndClass.lpszClassName=lpszClass;
	WndClass.lpszMenuName=NULL;
	WndClass.style=CS_HREDRAW | CS_VREDRAW;
	RegisterClass(&WndClass);

	hWnd=CreateWindow(lpszClass,lpszClass,WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
		NULL,(HMENU)NULL,hInstance,NULL);
	ShowWindow(hWnd,nCmdShow);
	hWndMain=hWnd;
	
	while(GetMessage(&Message,0,0,0)) {
		TranslateMessage(&Message);
		DispatchMessage(&Message);
	}
	return Message.wParam;
}

void Print(int Orient)
{
	PRINTDLG pd;
	HDC hPrtdc;
	DEVMODE *dm;
	int xpage, ypage;
	int dpiX, dpiY;
	HPEN hPen, OldPen;
	HFONT MyFont, OldFont;
	DOCINFO doc;
	int Result;
	char str[]=" ׽Ʈ";

	memset(&pd,0,sizeof(PRINTDLG));
	pd.lStructSize=sizeof(PRINTDLG);
	pd.Flags=PD_RETURNDC;
	pd.hwndOwner=hWndMain;
	pd.nFromPage=1;
	pd.nToPage=1;
	pd.nMinPage=1;
	pd.nMaxPage=1;
	pd.nCopies=1;

	pd.hDevMode=GlobalAlloc(GHND,sizeof(DEVMODE));
	dm=(DEVMODE *)GlobalLock(pd.hDevMode);
	dm->dmSize=sizeof(DEVMODE);
	dm->dmFields=DM_ORIENTATION;
	dm->dmOrientation=Orient;
	GlobalUnlock(pd.hDevMode);

	PrintDlg(&pd);
	hPrtdc=pd.hDC;
	if (hPrtdc == NULL) 
		return;

/*
	// ȭڸ  Ŀ    Ѵ.
	dm=(DEVMODE *)GlobalLock(pd.hDevMode);
	dm->dmFields=DM_ORIENTATION;
	dm->dmOrientation=Orient;
	ResetDC(hPrtdc,dm);
	GlobalUnlock(pd.hDevMode);
//*/

	// μ ۾ Ѵ.
	doc.cbSize=sizeof(DOCINFO);
	doc.lpszDocName="Test Document";
	doc.lpszOutput=NULL;
	doc.lpszDatatype=NULL;
	doc.fwType=0;
	Result=StartDoc(hPrtdc, &doc);
	if (Result <= 0) goto end;
	Result=StartPage(hPrtdc);
	if (Result <= 0) goto end;

	//  ػ󵵸 Ѵ.
	dpiX = GetDeviceCaps(hPrtdc, LOGPIXELSX);
	dpiY = GetDeviceCaps(hPrtdc, LOGPIXELSY);
	xpage = GetDeviceCaps(hPrtdc, HORZRES);
	ypage = GetDeviceCaps(hPrtdc, VERTRES);

	//  ׸.
	hPen=CreatePen(PS_SOLID,dpiY/10,RGB(0,0,255));
	OldPen=(HPEN)SelectObject(hPrtdc,hPen);
	Rectangle(hPrtdc,200,200,xpage-200,ypage-200);
	DeleteObject(SelectObject(hPrtdc,OldPen));

	// 1ġ=1/72Ʈ. ׷Ƿ nƮ ũ=n*1/72*dpi ȴ.
	MyFont=CreateFont(50*dpiY/72,0,0,0,FW_NORMAL, FALSE, FALSE, FALSE,
		HANGEUL_CHARSET, 3,2,1,VARIABLE_PITCH | FF_ROMAN, "ü");
	OldFont=(HFONT)SelectObject(hPrtdc, MyFont);
	SetTextAlign(hPrtdc,TA_CENTER);
	TextOut(hPrtdc,xpage/2,ypage/2,str,strlen(str));
	SelectObject(hPrtdc, OldFont);
	DeleteObject(MyFont);

	//  Ѵ.
	Result=EndPage(hPrtdc);
	if (Result <= 0) goto end;

	// μ ۾ .
	Result=EndDoc(hPrtdc);
end:
	if (pd.hDevMode)
		GlobalFree(pd.hDevMode);
	if (pd.hDevNames)
		GlobalFree(pd.hDevNames);
	DeleteDC(hPrtdc);
	SetCursor(LoadCursor(NULL,IDC_ARROW));
	return;
}

LRESULT CALLBACK WndProc(HWND hWnd,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	char Mes[]=" =  ,  = ";

	switch(iMessage) {
	case WM_LBUTTONDOWN:
		Print(DMORIENT_PORTRAIT);
		return 0;
	case WM_RBUTTONDOWN:
		Print(DMORIENT_LANDSCAPE);
		return 0;
	case WM_PAINT:
		hdc=BeginPaint(hWnd, &ps);
		TextOut(hdc,10,10,Mes,lstrlen(Mes));
		EndPaint(hWnd, &ps);
		return 0;
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}
	return(DefWindowProc(hWnd,iMessage,wParam,lParam));
}
