#include <windows.h>

LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);
HINSTANCE g_hInst;
HWND hWndMain;
LPCTSTR lpszClass=TEXT("DevMode");

int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance
	  ,LPSTR lpszCmdParam,int nCmdShow)
{
	HWND hWnd;
	MSG Message;
	WNDCLASS WndClass;
	g_hInst=hInstance;
	
	WndClass.cbClsExtra=0;
	WndClass.cbWndExtra=0;
	WndClass.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);
	WndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
	WndClass.hIcon=LoadIcon(NULL,IDI_APPLICATION);
	WndClass.hInstance=hInstance;
	WndClass.lpfnWndProc=(WNDPROC)WndProc;
	WndClass.lpszClassName=lpszClass;
	WndClass.lpszMenuName=NULL;
	WndClass.style=CS_HREDRAW | CS_VREDRAW;
	RegisterClass(&WndClass);

	hWnd=CreateWindow(lpszClass,lpszClass,WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
		NULL,(HMENU)NULL,hInstance,NULL);
	ShowWindow(hWnd,nCmdShow);
	hWndMain=hWnd;
	
	while(GetMessage(&Message,0,0,0)) {
		TranslateMessage(&Message);
		DispatchMessage(&Message);
	}
	return Message.wParam;
}

BOOL MyGetDefaultPrinter(char *DefPrinter)
{
	OSVERSIONINFO osv;
	DWORD dwNeed;
	char Buffer[255];

	osv.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
	GetVersionEx(&osv);

	// 2000 
	if (osv.dwMajorVersion >= 5) {
		dwNeed=128;
		if (GetDefaultPrinter(DefPrinter,&dwNeed)==0)
			return FALSE;
	// 95/98, NT 4.0
	} else {
		if (GetProfileString("windows","device",",,,",Buffer,255) <= 0)
			return FALSE;
		strtok(Buffer,",");
		lstrcpy(DefPrinter,Buffer);
	}

	return TRUE;
}

void DisplayDevMode2()
{
	char szPrinter[128];
	DWORD dwPrinter=128;
	HANDLE hPrinter;
	DEVMODE *dm;
	LONG ret;
	HDC hdc;
	int y=2;
	char Mes[256];

	hdc=GetDC(hWndMain);

	if (MyGetDefaultPrinter(szPrinter) == FALSE) {
		return;
	}
	OpenPrinter(szPrinter,&hPrinter,NULL);

	ret=DocumentProperties(hWndMain, hPrinter, szPrinter, NULL, NULL, 0);
	dm=(DEVMODE *)malloc(ret);
	DocumentProperties(hWndMain, hPrinter, szPrinter, dm, NULL, DM_OUT_BUFFER);

	// ʱȭ  
	wsprintf(Mes,"⺻  ̸=%s",dm->dmDeviceName);
	TextOut(hdc,10,y++*20,Mes,lstrlen(Mes));
	wsprintf(Mes,"̹ =%d", dm->dmDriverVersion);
	TextOut(hdc,10,y++*20,Mes,lstrlen(Mes));
	wsprintf(Mes,"  ũ=%d, ̹   ũ=%d", 
		dm->dmSize, dm->dmDriverExtra);
	TextOut(hdc,10,y++*20,Mes,lstrlen(Mes));
	wsprintf(Mes," =%d, =%d, =%d,  =%s", 
		dm->dmPaperSize, dm->dmPaperWidth, dm->dmPaperLength, 
		dm->dmOrientation == DMORIENT_PORTRAIT  ? "":"");
	TextOut(hdc,10,y++*20,Mes,lstrlen(Mes));
	wsprintf(Mes,"Xػ=%d, Yػ=%d", dm->dmPrintQuality, dm->dmYResolution);
	TextOut(hdc,10,y++*20,Mes,lstrlen(Mes));

	free(dm);
	ClosePrinter(hPrinter);
	ReleaseDC(hWndMain,hdc);
}

void DisplayDevMode1()
{
	PRINTDLG pd;
	HDC hPrtdc;
	DEVMODE *dm;
	char szPrinter[128];
	char Mes[256];
	HDC hdc;
	int y=2;

	hdc=GetDC(hWndMain);

	// Ϳ   ϰ DC .
	memset(&pd,0,sizeof(PRINTDLG));
	pd.lStructSize=sizeof(PRINTDLG);
	pd.Flags=PD_RETURNDC;
	pd.hwndOwner=hWndMain;
	pd.nFromPage=1;
	pd.nToPage=1;
	pd.nMinPage=1;
	pd.nMaxPage=1;
	pd.nCopies=1;
	PrintDlg(&pd);
	hPrtdc=pd.hDC;
	if (hPrtdc == NULL) 
		return;

	// DEVMODE  Ѵ.
	dm=(DEVMODE *)GlobalLock(pd.hDevMode);
	lstrcpy(szPrinter,(LPCTSTR)dm->dmDeviceName);

	// ʱȭ  
	wsprintf(Mes,"  ̸=%s",dm->dmDeviceName);
	TextOut(hdc,10,y++*20,Mes,lstrlen(Mes));
	wsprintf(Mes,"̹ =%d", dm->dmDriverVersion);
	TextOut(hdc,10,y++*20,Mes,lstrlen(Mes));
	wsprintf(Mes,"  ũ=%d, ̹   ũ=%d", 
		dm->dmSize, dm->dmDriverExtra);
	TextOut(hdc,10,y++*20,Mes,lstrlen(Mes));
	wsprintf(Mes," =%d, =%d, =%d,  =%s", 
		dm->dmPaperSize, dm->dmPaperWidth, dm->dmPaperLength, 
		dm->dmOrientation == DMORIENT_PORTRAIT  ? "":"");
	TextOut(hdc,10,y++*20,Mes,lstrlen(Mes));
	wsprintf(Mes,"Xػ=%d, Yػ=%d", dm->dmPrintQuality, dm->dmYResolution);
	TextOut(hdc,10,y++*20,Mes,lstrlen(Mes));

	GlobalUnlock(pd.hDevMode);
	ReleaseDC(hWndMain,hdc);
}

LRESULT CALLBACK WndProc(HWND hWnd,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	char Mes[]=" ư= ,  ư=⺻  ";

	switch(iMessage) {
	case WM_LBUTTONDOWN:
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		DisplayDevMode1();
		return 0;
	case WM_RBUTTONDOWN:
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		DisplayDevMode2();
		return 0;
	case WM_PAINT:
		hdc=BeginPaint(hWnd, &ps);
		TextOut(hdc,10,10,Mes,lstrlen(Mes));
		EndPaint(hWnd, &ps);
		return 0;
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}
	return(DefWindowProc(hWnd,iMessage,wParam,lParam));
}
