#include <windows.h>

LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);
HINSTANCE g_hInst;
HWND hWndMain;
LPCTSTR lpszClass=TEXT("LandPort2");

int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance
	  ,LPSTR lpszCmdParam,int nCmdShow)
{
	HWND hWnd;
	MSG Message;
	WNDCLASS WndClass;
	g_hInst=hInstance;
	
	WndClass.cbClsExtra=0;
	WndClass.cbWndExtra=0;
	WndClass.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);
	WndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
	WndClass.hIcon=LoadIcon(NULL,IDI_APPLICATION);
	WndClass.hInstance=hInstance;
	WndClass.lpfnWndProc=(WNDPROC)WndProc;
	WndClass.lpszClassName=lpszClass;
	WndClass.lpszMenuName=NULL;
	WndClass.style=CS_HREDRAW | CS_VREDRAW;
	RegisterClass(&WndClass);

	hWnd=CreateWindow(lpszClass,lpszClass,WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
		NULL,(HMENU)NULL,hInstance,NULL);
	ShowWindow(hWnd,nCmdShow);
	hWndMain=hWnd;
	
	while(GetMessage(&Message,0,0,0)) {
		TranslateMessage(&Message);
		DispatchMessage(&Message);
	}
	return Message.wParam;
}

BOOL MyGetDefaultPrinter(char *DefPrinter)
{
	OSVERSIONINFO osv;
	DWORD dwNeed;
	char Buffer[255];

	osv.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
	GetVersionEx(&osv);

	// 2000 
	if (osv.dwMajorVersion >= 5) {
		dwNeed=128;
		if (GetDefaultPrinter(DefPrinter,&dwNeed)==0)
			return FALSE;
	// 95/98, NT 4.0
	} else {
		if (GetProfileString("windows","device",",,,",Buffer,255) <= 0)
			return FALSE;
		strtok(Buffer,",");
		lstrcpy(DefPrinter,Buffer);
	}

	return TRUE;
}

void Print(int Orient, int nCopy)
{
	HDC hPrtdc;
	int xpage, ypage;
	int dpiX, dpiY;
	HPEN hPen, OldPen;
	HFONT MyFont, OldFont;
	DOCINFO doc;
	int Result;
	char str[]=" ׽Ʈ";

	char szPrinter[128];
	DWORD dwPrinter=128;
	HANDLE hPrinter;
	DEVMODE *dmo;

	SetCursor(LoadCursor(NULL,IDC_WAIT));

	// ⺻   Ѵ.  ʵ常 缳Ѵ.
	if (MyGetDefaultPrinter(szPrinter) == FALSE)
		return;
	OpenPrinter(szPrinter,&hPrinter,NULL);
	Result=DocumentProperties(hWndMain, hPrinter, szPrinter, NULL, NULL, 0);
	dmo=(DEVMODE *)malloc(Result);
	DocumentProperties(hWndMain, hPrinter, szPrinter, dmo, NULL, DM_OUT_BUFFER);
	dmo->dmFields=DM_ORIENTATION | DM_COPIES;
	dmo->dmOrientation = Orient;
	dmo->dmCopies = nCopy;
	DocumentProperties(hWndMain, hPrinter, szPrinter, dmo, dmo, DM_OUT_BUFFER | DM_IN_BUFFER);

	hPrtdc=CreateDC(NULL,szPrinter,NULL,dmo);

	if (hPrtdc==NULL) 
		goto end;

	// μ ۾ Ѵ.
	doc.cbSize=sizeof(DOCINFO);
	doc.lpszDocName="Test Document";
	doc.lpszOutput=NULL;
	doc.lpszDatatype=NULL;
	doc.fwType=0;
	Result=StartDoc(hPrtdc, &doc);
	if (Result <= 0) goto end;
	Result=StartPage(hPrtdc);
	if (Result <= 0) goto end;

	//  ػ󵵸 Ѵ.
	dpiX = GetDeviceCaps(hPrtdc, LOGPIXELSX);
	dpiY = GetDeviceCaps(hPrtdc, LOGPIXELSY);
	xpage = GetDeviceCaps(hPrtdc, HORZRES);
	ypage = GetDeviceCaps(hPrtdc, VERTRES);

	//  ׸.
	hPen=CreatePen(PS_SOLID,dpiY/10,RGB(0,0,255));
	OldPen=(HPEN)SelectObject(hPrtdc,hPen);
	Rectangle(hPrtdc,200,200,xpage-200,ypage-200);
	DeleteObject(SelectObject(hPrtdc,OldPen));

	// 1ġ=1/72Ʈ. ׷Ƿ nƮ ũ=n*1/72*dpi ȴ.
	MyFont=CreateFont(50*dpiY/72,0,0,0,FW_NORMAL, FALSE, FALSE, FALSE,
		HANGEUL_CHARSET, 3,2,1,VARIABLE_PITCH | FF_ROMAN, "ü");
	OldFont=(HFONT)SelectObject(hPrtdc, MyFont);
	SetTextAlign(hPrtdc,TA_CENTER);
	TextOut(hPrtdc,xpage/2,ypage/2,str,strlen(str));
	SelectObject(hPrtdc, OldFont);
	DeleteObject(MyFont);

	//  Ѵ.
	Result=EndPage(hPrtdc);
	if (Result <= 0) goto end;

	// μ ۾ .
	Result=EndDoc(hPrtdc);
end:
	free(dmo);
	ClosePrinter(hPrinter);
	DeleteDC(hPrtdc);
	SetCursor(LoadCursor(NULL,IDC_ARROW));
	return;
}

LRESULT CALLBACK WndProc(HWND hWnd,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	char Mes[]=" =  ,  = ";

	switch(iMessage) {
	case WM_LBUTTONDOWN:
		Print(DMORIENT_PORTRAIT,1);
		return 0;
	case WM_RBUTTONDOWN:
		Print(DMORIENT_LANDSCAPE,2);
		return 0;
	case WM_PAINT:
		hdc=BeginPaint(hWnd, &ps);
		TextOut(hdc,10,10,Mes,lstrlen(Mes));
		EndPaint(hWnd, &ps);
		return 0;
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}
	return(DefWindowProc(hWnd,iMessage,wParam,lParam));
}
